/**
 * 
 */
package be.ASPL.presentationlayer;

import java.util.Locale;
import java.util.Properties;

/**
 * @author Erwin
 * 
 */
final class ImageRenderer extends Renderer {

	/**
	 * No need to specify a default css class for this renderer.
	 */
	private static final String DEFAULTCSSCLASS = ""; //$NON-NLS-1$

	/**
	 * 
	 */
	private static Renderer instance = new ImageRenderer();

	/**
	 * @return
	 */
	static Renderer getInstance ( ) {
		return instance;
	}

	/**
	 * Creates the GenericDateRenderer
	 * 
	 */
	private ImageRenderer ( ) {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.ASPL.presentationlayer.Renderer#emptyHTML(be.erwinsmout.ASPL.presentationlayer.PresentationField)
	 */
	@Override
	String getEmptyHTML (PresentationField presentationField, Locale locale, Properties presentationLocaleLabels) {
		return ""; //$NON-NLS-1$
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.ASPL.presentationlayer.Renderer#renderHTML(be.erwinsmout.ASPL.WaarValue, be.erwinsmout.ASPL.presentationlayer.OnLinePresentationFunction, be.erwinsmout.ASPL.presentationlayer.PresentationField)
	 */
	@Override
	String getHTML (PresentationValue presentationFieldValue, OnLinePresentationFunction userFunction, PresentationField presentationField, Locale locale, Properties presentationLocaleLabels) {
		BlobValue imageValue = (BlobValue) presentationFieldValue;

		return "<IMG" + getHTMLCssClassSpec(presentationField, DEFAULTCSSCLASS) + " " + getHTMLControlNameSpec(presentationField) + getHTMLSizeAttributeSpec(presentationField) + getHTMLTabIndexSpec(presentationField) + " value=\"" + imageValue + "\">"; //$NON-NLS-1$//$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
	}
}
