/**
 * 
 */
package be.ASPL.presentationlayer;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Inherited;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * @author Erwin
 * 
 */
@Target(ElementType.TYPE)
@Retention(RetentionPolicy.RUNTIME)
@Documented
@Inherited
public @interface InitialPresentation {

	/**
	 * The name of the initial presentation to be shown by an {@link OnLinePresentationFunction}
	 * 
	 * @return The name of the initial presentation to be shown by an {@link OnLinePresentationFunction}
	 */
	public Class<? extends Presentation> initialPresentationClass();
}
