/**
 * 
 */
package be.ASPL.presentationlayer;

import java.lang.annotation.*;

/**
 * OnLinePresentationFunctionCharacteristics facilitates encoding the OnLinePresentationFunctionCharacteristics information associated with an ASPL online presentation function as an annotation
 * 
 * @author erwin
 * 
 */
@Retention(value = RetentionPolicy.RUNTIME)
@Target(ElementType.TYPE)
@Documented
@Inherited
public @interface OnLinePresentationFunctionCharacteristics {

	/**
	 * Flag indicating whether the function must be left after processing the OK button without an exception.
	 * 
	 * @return Flag indicating whether the function must be left after processing the OK button without an exception.
	 */
	public boolean leaveFunctionOnExit();

	/**
	 * Gets the key to be used by the Localizer in order to obtain the presentation function's description
	 * 
	 * @return The key to be used by the Localizer in order to obtain the presentation function's description
	 */
	public String descriptionLocalizationKey();
}
