/**
 * 
 */
package be.ASPL.presentationlayer;

import java.util.Locale;
import java.util.Properties;

/**
 * @author Erwin
 * 
 */
final class PassWordRenderer extends Renderer {

	/**
	 * 
	 */
	private static final String DEFAULTCSSCLASS = "inputpassword"; //$NON-NLS-1$

	/**
	 * 
	 */
	private static Renderer instance = new PassWordRenderer();

	/**
	 * @return
	 */
	static Renderer getInstance ( ) {
		return instance;
	}

	/**
	 * 
	 */
	private static final String asterisks = "********"; //$NON-NLS-1$

	/**
	 * Creates the GenericDateRenderer
	 * 
	 */
	private PassWordRenderer ( ) {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.ASPL.presentationlayer.Renderer#emptyHTML(be.erwinsmout.ASPL.presentationlayer.PresentationField)
	 */
	@Override
	String getEmptyHTML (PresentationField presentationField, Locale locale, Properties presentationLocaleLabels) {
		if (presentationField.isInputEnabled()) {
			return "<INPUT" + getHTMLCssClassSpec(presentationField, DEFAULTCSSCLASS) + " type=\"password\"" + getHTMLControlNameSpec(presentationField) + getHTMLSizeAttributeSpec(presentationField) + getHTMLTabIndexSpec(presentationField) + " value=\"\">"; //$NON-NLS-1$//$NON-NLS-2$ //$NON-NLS-3$
		} else {
			return ""; //$NON-NLS-1$
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.ASPL.presentationlayer.Renderer#renderHTML(be.erwinsmout.ASPL.WaarValue, be.erwinsmout.ASPL.presentationlayer.OnLinePresentationFunction, be.erwinsmout.ASPL.presentationlayer.PresentationField)
	 */
	@Override
	String getHTML (PresentationValue presentationFieldValue, OnLinePresentationFunction userFunction, PresentationField presentationField, Locale locale, Properties presentationLocaleLabels) {
		String stringValue = processEntityRefs(presentationFieldValue.toASPLString(userFunction.getUserData()));

		if (presentationField.isInputEnabled()) {
			return "<INPUT" + getHTMLCssClassSpec(presentationField, DEFAULTCSSCLASS) + " type=\"password\"" + getHTMLControlNameSpec(presentationField) + getHTMLSizeAttributeSpec(presentationField) + getHTMLTabIndexSpec(presentationField) + " value=\"" + stringValue + "\">"; //$NON-NLS-1$//$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		} else {
			return asterisks.substring(0, Math.min(asterisks.length(), stringValue.length()));
		}
	}
}
