/**
 * 
 */
package be.ASPL.presentationlayer;

import java.util.Locale;
import java.util.Properties;

/**
 * @author Erwin
 * 
 */
final class RadioButtonRenderer extends Renderer {

	/**
	 * 
	 */
	private static final String DEFAULTCSSCLASS = "inputradiobutton"; //$NON-NLS-1$

	/**
	 * 
	 */
	private static Renderer instance = new RadioButtonRenderer();

	/**
	 * @return
	 */
	static Renderer getInstance ( ) {
		return instance;
	}

	/**
	 * Creates the RadioButtonRenderer
	 * 
	 */
	private RadioButtonRenderer ( ) {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.ASPL.presentationlayer.Renderer#emptyHTML(be.erwinsmout.ASPL.presentationlayer.PresentationField)
	 */
	@Override
	String getEmptyHTML (PresentationField presentationField, Locale locale, Properties presentationLocaleLabels) {
		return getHTML(null, null, presentationField, locale, presentationLocaleLabels);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.ASPL.presentationlayer.Renderer#renderHTML(be.erwinsmout.ASPL.WaarValue, be.erwinsmout.ASPL.presentationlayer.OnLinePresentationFunction, be.erwinsmout.ASPL.presentationlayer.PresentationField)
	 */
	@Override
	String getHTML (PresentationValue presentationFieldValue, OnLinePresentationFunction userFunction, PresentationField presentationField, Locale locale, Properties presentationLocaleLabels) {
		String[] labels = ((NumberedEnumerationType) presentationField.getType()).getLabels();
		if (presentationFieldValue instanceof NumberedEnumerationValue) {
			NumberedEnumerationValue numberedEnumerationValue = (NumberedEnumerationValue) presentationFieldValue;
			int offsetValue = numberedEnumerationValue.getIntegerValue() - 1;
			StringBuilder htmlFieldValue = new StringBuilder(80 * labels.length);
			int c = 0;
			while (c < labels.length) {
				if (c > 0) {
					htmlFieldValue.append("<BR>"); //$NON-NLS-1$
				}
				String cookedLabel = processEntityRefs(labels[c]);
				htmlFieldValue.append("<INPUT" + getHTMLCssClassSpec(presentationField, DEFAULTCSSCLASS) + " TYPE=\"RADIO\"").append(getHTMLControlNameSpec(presentationField)).append(getHTMLTabIndexSpec(presentationField)).append(" VALUE=\"").append(cookedLabel).append("\" ").append((c == offsetValue ? "CHECKED" : "")).append(" >").append(cookedLabel).append("</INPUT>"); //$NON-NLS-1$//$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$ //$NON-NLS-7$ //$NON-NLS-8$
				c++;
			}
			return htmlFieldValue.toString();
		} else {
			if (presentationFieldValue == null) {
				StringBuilder htmlFieldValue = new StringBuilder(80 * labels.length);
				int c = 0;
				while (c < labels.length) {
					if (c > 0) {
						htmlFieldValue.append("<BR>"); //$NON-NLS-1$
					}
					String cookedLabel = processEntityRefs(labels[c]);
					htmlFieldValue.append("<INPUT" + getHTMLCssClassSpec(presentationField, DEFAULTCSSCLASS) + " TYPE=\"RADIO\"").append(getHTMLControlNameSpec(presentationField)).append(getHTMLTabIndexSpec(presentationField)).append(" VALUE=\"").append(cookedLabel).append("\" ").append(" >").append(cookedLabel).append("</INPUT>"); //$NON-NLS-1$//$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
					c++;
				}
				return htmlFieldValue.toString();
			} else {
				throw new IllegalArgumentException(presentationFieldValue.getClass().getName());
			}
		}
	}
}
