package be.ASPL.webclient;

import be.ASPL.presentationlayer.Architecture;
import be.ASPL.presentationlayer.InitialPresentation;
import be.ASPL.presentationlayer.Presentation;
import be.ASPL.presentationlayer.StringValue;
import be.ASPL.presentationlayer.ASPLException;

/**
 * @version 1.0
 * @author Erwin
 */
@InitialPresentation(initialPresentationClass = UsersCreatePresentation.class)
public class UsersCreate extends UsersFunction {

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.PresentationFunction#doInitialLogic()
	 */
	public void doInitialLogic ( ) throws ASPLException {
		if (!getPresentation().getName().equalsIgnoreCase(UsersVoid)) {
			setPresentationValue("LANGUAGE", Architecture.getDefaultLocale().getLanguage()); //$NON-NLS-1$
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.PresentationFunction#doPresentationLogic()
	 */
	public void doPresentationLogic ( ) throws ASPLException {
		if (!getPresentation().getName().equalsIgnoreCase(UsersVoid)) {
			Architecture.newWaarUser(getApplicationName(), ((StringValue) getPresentationValue("USERID")).getString(), ((StringValue) getPresentationValue("PASSWORD")).getString(), ((StringValue) getPresentationValue("LANGUAGE")).getString(), ((StringValue) getPresentationValue("ROLES")).getString().toLowerCase()); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.PresentationFunction#getInitialPresentationClass()
	 */
	public Class<? extends Presentation> getInitialPresentationClass ( ) {
		if (getUserRoles().contains(Architecture.ASPLADMINISTRATOR_ROLENAME)) {
			return UsersCreatePresentation.class;
		} else {
			return UsersVoidPresentation.class;
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.PresentationFunction#getPresentationFunctionDescription()
	 */
	public String getPresentationFunctionDescription () {
		return "Define a new WAAR user"; //$NON-NLS-1$
	}
}
