/**
 * 
 */
package be.SIRAPRISE.birdwatcher;

import be.SIRAPRISE.client.jsba.AbstractUpdatableDBObject;
import be.SIRAPRISE.client.jsba.AttributeDef;
import be.SIRAPRISE.client.jsba.Relvars;
import be.SIRAPRISE.client.jsba.GetterMethod;
import be.SIRAPRISE.client.jsba.UpdatableDBObject;
import be.SIRAPRISE.typeimplementations.DbmsStringImplementation;
import be.SIRAPRISE.typeimplementations.TYPENAMES;
import be.SIRAPRISE.typeimplementations.ValueBuffer;

/**
 * @author Erwin
 * 
 */
@Relvars(relvarNames = { RELVARNAMES.EXISTINGSPECIES, RELVARNAMES.POSSIBLESPECIES })
public final class ExistingSpecies extends AbstractUpdatableDBObject {

	/**
	 * 
	 */
	private ExistingSpecies preUpdateState;

	/**
	 * The scientific name
	 */
	private String speciesName;

	/**
	 * Creates the ExistingSpecies
	 */
	public ExistingSpecies ( ) {
		this(""); //$NON-NLS-1$
	}

	/**
	 * Creates the ExistingSpecies
	 * 
	 * @param speciesName
	 *            The scientific name
	 */
	public ExistingSpecies (String speciesName) {
		this.speciesName = speciesName;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.client.UpdatableDBObject#getPreUpdateState()
	 */
	@Override
	public UpdatableDBObject getPreUpdateState ( ) {
		return preUpdateState;
	}

	/**
	 * Gets The scientific name
	 * 
	 * @return The scientific name
	 */
	@GetterMethod(attributeDefs = { @AttributeDef(attributeName = "SPECIESNAME", requiresEscaping = true, typeName = TYPENAMES.STRING) }, relvarNames = { RELVARNAMES.EXISTINGSPECIES, RELVARNAMES.POSSIBLESPECIES })
	public final String getSpeciesName ( ) {
		return speciesName;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.client.UpdatableDBObject#setPreUpdateState()
	 */
	@Override
	public final void setPreUpdateState ( ) {
		preUpdateState = new ExistingSpecies(speciesName);
	}

	/**
	 * Sets The scientific name
	 * 
	 * @param speciesName
	 *            The scientific name
	 */
	public final void setSpeciesName (String speciesName) {
		this.speciesName = speciesName;
	}

	/**
	 * Sets The scientific name
	 * 
	 * @param speciesName
	 *            The scientific name
	 */
	@AttributeDef(attributeName = "SPECIESNAME", requiresEscaping = true, typeName = TYPENAMES.STRING)
	public final void setSpeciesName (ValueBuffer speciesName) {
		this.speciesName = DbmsStringImplementation.getJavaString(speciesName);
	}
}
