package be.SIRAPRISE.birdwatcher;

import be.ASPL.presentationlayer.*;
import be.SIRAPRISE.client.*;
import be.SIRAPRISE.client.jsba.DmlCommand;
import be.SIRAPRISE.messages.ErrorMessageException;

/**
 * The function to create a new existing species
 * 
 * @author Erwin
 */
@InitialPresentation(initialPresentationClass = PossibleSpeciesPresentation.class)
@OnLinePresentationFunctionCharacteristics(leaveFunctionOnExit = true, descriptionLocalizationKey = "PossibleSpeciesDelete.Text")
public class PossibleSpeciesDelete extends BWWebClientFunction {

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.OnLinePresentationFunction#doPresentationLogic()
	 */
	public void doPresentationLogic ( ) throws ASPLException {
		
		try (DBConnection dbc = getDBConnection();) {
			DmlCommand.execDmlCommandAndEndTransaction(dbc.startTransaction(getUserData().getUserID(), true, "", new byte[] {}, TransactionMode.UPDATE), new ExistingSpecies(((StringValue) getPresentationValue(ATTRIBUTENAMES.SPECIESNAME)).getString()).dbUnAssertCommand(RELVARNAMES.POSSIBLESPECIES)); //$NON-NLS-1$
		} catch (ConnectionClosedException e) {
			log(e);
			throw new ASPLApplicationException(e);
		} catch (ErrorMessageException e) {
			log(e);
			throw new ASPLApplicationException(e);
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.OnLinePresentationFunction#doResumeLogic()
	 */
	public void doResumeLogic ( ) throws ASPLException {
		doPresentationLogic();
	}
}