/**
 * 
 */
package be.SIRAPRISE.tests.officialtestset;

import java.io.PrintStream;
import java.util.logging.Level;
import java.util.logging.LogRecord;

import be.SIRAPRISE.messages.ErrorMessageException;
import be.SIRAPRISE.typeimplementations.Relation;
import be.SIRAPRISE.util.MyMessageFormat;

/**
 * ComparisonOfResultsFailed
 * 
 * @author erwin
 */
final class ComparisonOfResultsFailed extends TestResultDetails {

	/**
	 * 
	 */
	private ErrorMessageException e;

	/**
	 * 
	 */
	private String expectedRelationValue;

	/**
	 * 
	 */
	private Relation result;

	/**
	 * Creates the ComparisonOfResultsFailed
	 * 
	 * @param e
	 * @param result
	 * @param expectedRelationValue
	 */
	ComparisonOfResultsFailed (ErrorMessageException e, Relation result, String expectedRelationValue) {
		this.e = e;
		this.result = result;
		this.expectedRelationValue = expectedRelationValue;
	}

	/**
	 * @return
	 */
	private String message ( ) {
		return MyMessageFormat.format("Comparison of result {2} against expected relation value {3} failed with exception type {0} and message {1}", new String[] { e.getClass().getName(), e.getMessage(), result.printValueEscapedWithTypeNames(), expectedRelationValue }); //$NON-NLS-1$
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.tests.officialtestset.TestResultDetails#getLogRecord()
	 */
	@Override
	LogRecord getLogRecord ( ) {
		return new LogRecord(Level.WARNING, message());
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.tests.officialtestset.TestResultDetails#log(java.io.PrintStream)
	 */
	@Override
	void log (PrintStream out) {
		out.println(message());
	}

}
